/**
 *	@file	AccelManager.h
 *	@brief	L[ANZ[^(V[gJbgL[)Ɋւ鏈󂯎NXQ
 *	@note
 *	CKeyHelper
 *	CAccelerManager
 *	CEditAccel
 *	L
 */


#ifndef __ACCELMANAGER_H__
#define __ACCELMANAGER_H__

#if _MSC_VER > 1000
 #pragma once
#endif	// _MSC_VER > 1000

#include <windows.h>
#include <atlbase.h>
#include <atlapp.h>
#include <atlmisc.h>
#include <atlctrls.h>



/*
	CKeyHelper
	ANZ[^L[̏񂩂V[gJbgL[𐶐wpNX

	CKeyHelper1V[gJbgL[̏Ԃ"Ctrl+Shift+R","F8"̂悤ȕ
	V[gJbgL[߂̕⏕NXłB

	CKeyHelper(lpAccel);܂SetAccelerator(lpAccel)Ăяo
	擾ANZ[^ݒ肵܂B
	Format֐Ăяoƈ̎QƂĕ𓾂邱Ƃo܂B
 */
class CKeyHelper {
protected:
	//oϐ
	LPACCEL 	m_lpAccel;									//ANZ[^̃|C^

	//֐
	//void		AddVirtKeyStr(CString &str, UINT uiVirtKey, BOOL bLast = FALSE) const;
	bool		AddVirtKeyStr(CString &str, UINT uiVirtKey, LPCTSTR xname=NULL, BOOL bLast = FALSE) const;

public:
	//Ej
	CKeyHelper();											//ftHgRXgN^
	CKeyHelper(LPACCEL lpAccel);							//p[^tRXgN^
	virtual ~CKeyHelper();									//fXgN^

	//
	bool		Format(CString &str) const; 				//ANZ[^̐ݒɂ鏑

	//
	void		SetAccelerator(LPACCEL lpAccel);			//NXŎ舵ANZ[^̎w
};



/*
	CAccelerManager
	ANZ[^e[uƌʂ̃ANZ[^Ɋւ郁\bhL
	ANZ[^ǗNX

	ANZ[^e[uɑ΂ăR}hIDɂ錟AdA
	ANZ[^̒ǉ폜Ƃ@\L܂B܂t@C
	[hEZ[u@\ɂăL[ANZ[^̏ۑEĐł܂B

	RXgN^ĂяoăL[ANZ[^̃nhݒ肵܂B
	Ƃ͊e֐Ăяo܂B
 */
class CAccelerManager {
private:
	//oϐ
	HACCEL		m_hAccel;									//ANZ[^e[ũnh
	LPACCEL 	m_lpAccel;									//ANZ[^W̃|C^
	int 		m_nAccelSize;								//ANZ[^̐

public:
	CAccelerManager(HACCEL hAccel); 						//RXgN^
	virtual ~CAccelerManager(); 							//fXgN^

	int 		GetCount() const;							//e[ũANZ[^̐擾
	LPACCEL 	GetAt(int index);							//w肵ԍ̃ANZ[^擾(0origin)
	BOOL		FindAccelerator(UINT uiCmd, CString &str);	//w肵R}hIDANZ[^

	//߂l͌ǂBꍇɂ
	//strɃL[̑gݍ킹񂪕Ԃ
	UINT		FindCommandID(ACCEL *pAccel);				//w肵ANZ[^ƃL[v̂̃R}hIDԂ

	//Ȃꍇ0Ԃ
	HACCEL		DeleteAccelerator(UINT uCmd);				//w肵R}hIDANZ[^폜
	HACCEL		AddAccelerator(ACCEL *lpAccel); 			//w肵ANZ[^e[uɒǉ
	HACCEL		LoadAccelaratorState(HACCEL hAccel);		//t@CANZ[^̏[h

	//(minit)̓t@Cǂ߂Ȃꍇ̑փANZ[^e[u?
	BOOL		SaveAccelaratorState(); 					//t@CɃANZ[^e[ȕԂL^
};



/*
	CEditAccel
	zbgL[Rg[̂悤ȃeLXg{bNXNX

	L[{[hbZ[W߂ē͂ɉđΉL[\
	eLXg{bNX쐬܂B

 ##Rgǉr##

 */
class CEditAccel : public CContainedWindowT < CEdit > {
private:
	BOOL	   m_bKeyDefined;
	CKeyHelper m_Helper;
	ACCEL	   m_Accel;

	void		SetAccelFlag(BYTE bFlag, BOOL bOn);

public:
	CEditAccel();

	ACCEL const *GetAccel() const;
	void		ResetKey();
	BOOL		OnTranslateAccelerator(MSG *pMsg);
};



#endif
