/**
 *	@file	UrlSecurityExPropDialog.h
 *	@brief	UrlʃZLeB(gvpeB)ݒ
 */

#pragma once

#include "../ExStyle.h"


//gvpeBf[^ݒp_CAO
class CExPropertyDialog2 : public CDialogImpl<CExPropertyDialog2> , public CWinDataExchange<CExPropertyDialog2> {
public:
	enum { IDD = IDD_DIALOG_EXPROPERTY2 };

private:
  #ifndef USE_DIET
	BOOL		m_bRegex;
  #endif
	DWORD		m_dwExProp;
	int 		m_nDLActiveX;
	int 		m_nImage;
	int 		m_nJava;
	int 		m_nNaviLock;
	int 		m_nRunActiveX;
	int 		m_nScript;
	int 		m_nScrollBar;
	int 		m_nSound;
	int 		m_nVideo;
	int 		m_nBlockMailTo;
	int 		m_nGesture;
	int 		m_nFilter;
	int 		m_nReload;

	int			m_urlEditBtnSw;			//+++ urlҏWon,off
	CString&	m_rRsltUrl;			//+++ GfBbg`FbNp
	unsigned&	m_rRsltFlags;
	unsigned&	m_rRsltExopts;

public:
	CExPropertyDialog2(CString &strUrlFile, unsigned& rFlags, unsigned& rExopts)
		: m_rRsltUrl(strUrlFile)
		, m_rRsltFlags(rFlags)
		, m_rRsltExopts(rExopts)
		, m_urlEditBtnSw(0)
	  #ifndef USE_DIET
		, m_bRegex((rFlags & 1) != 0)
	  #endif
	{
		DWORD		dwExProp  = rExopts;

		m_nImage			= exProp2btn(dwExProp, EXPROP_DLIMAGE	);
		m_nVideo			= exProp2btn(dwExProp, EXPROP_VIDEO		);
		m_nSound			= exProp2btn(dwExProp, EXPROP_SOUND		);
		m_nRunActiveX		= exProp2btn(dwExProp, EXPROP_RUNACTIVEX );
		m_nDLActiveX		= exProp2btn(dwExProp, EXPROP_DLACTIVEX	);
		m_nScript			= exProp2btn(dwExProp, EXPROP_SCRIPT 	);
		m_nJava 			= exProp2btn(dwExProp, EXPROP_JAVA		);

		m_nNaviLock 		= exProp2btn(dwExProp, EXPROP_NAVI		);
		m_nFilter			= exProp2btn(dwExProp, EXPROP_FILTER 	);
		m_nGesture			= exProp2btn(dwExProp, EXPROP_GETSTURE	);
		m_nBlockMailTo		= exProp2btn(dwExProp, EXPROP_MAILTO 	);

		//+++ m_nNoCloseNaviLock =	gvpeBł͐ݒłȂƂɂ.

		int   nFlag 		= dwExProp / EXPROP_REFRESH_NONE;
		m_nReload			= 0;

		while ( (nFlag >>= 1) > 0 )
			m_nReload++;
	}


	BEGIN_DDX_MAP(CExPropertyDialogT<IDD_DLG> )
		DDX_CHECK(IDC_CHECK_DLACTIVEXCTLS	, m_nDLActiveX	)
		DDX_CHECK(IDC_CHECK_IMAGE			, m_nImage		)
		DDX_CHECK(IDC_CHECK_JAVA			, m_nJava		)
		DDX_CHECK(IDC_CHECK_NAVILOCK		, m_nNaviLock	)
		DDX_CHECK(IDC_CHECK_RUNACTIVEXCTLS	, m_nRunActiveX )
		DDX_CHECK(IDC_CHECK_SCRIPTS 		, m_nScript 	)
		DDX_CHECK(IDC_CHECK_SOUND			, m_nSound		)
		DDX_CHECK(IDC_CHECK_VIDEO			, m_nVideo		)
		DDX_CHECK(IDC_CHK_BLOCK_MAILTO		, m_nBlockMailTo)
		DDX_CHECK(IDC_CHK_MOUSE_GESTURE 	, m_nGesture	)
		DDX_CHECK(IDC_CHK_MSG_FILTER		, m_nFilter 	)
		DDX_RADIO(IDC_RADIO_RELOAD_NONE 	, m_nReload 	)
	  #ifndef USE_DIET
		DDX_CHECK(IDC_CHK_URLSEC_REGEX		, m_bRegex		)
	  #endif
	END_DDX_MAP()


	BEGIN_MSG_MAP(CExPropertyDialogT<IDD_DLG> )
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER_EX(IDOK				, OnOK		)
		COMMAND_ID_HANDLER_EX(IDCANCEL			, OnCancel	)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_DELETE , OnDelete	)
		COMMAND_ID_HANDLER_EX(IDC_BUTTON_DEFAULT, OnDefault )
		COMMAND_ID_HANDLER_EX(IDC_BTN_DFLTBASE  , OnDfltBase )
		COMMAND_ID_HANDLER_EX(IDC_BTN_EXPROP_URL, OnBtnExpropUrl )
	END_MSG_MAP()


private:
	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam)
	{
		CEdit( GetDlgItem(IDC_EDIT_EXPROP_URL) ).SetWindowText(m_rRsltUrl);
		CEdit( GetDlgItem(IDC_EDIT_EXPROP_URL) ).SetReadOnly(1);
		m_urlEditBtnSw = 0;
		CEdit( GetDlgItem(IDC_EDIT_EXPROP_URL) ).EnableWindow(1);
		CButton( GetDlgItem(IDC_BTN_EXPROP_URL) ).EnableWindow(1);

		DoDataExchange(FALSE);
		return 1;
	}

	//+++ gvpeB{^Ԃɕϊ.
	static int		exProp2btn(DWORD dwExProp, DWORD flag) {
		return (dwExProp & flag) / (flag / 3);
	}


	//+++ gvpeBݒ
	static DWORD	btn2ExProp(int stat, DWORD flag) {
	  #if 1
		if (stat == BST_UNCHECKED)
			return 0;					//+++ `FbNĂȂꍇ
		if (stat == BST_INDETERMINATE)
			return 2 * flag / 3;		//+++ ftHgݒpꍇ
		return flag / 3;				//+++ `FbNĂꍇ
	  #else
		return stat * (flag / 3);
	  #endif
	}


	void OnOK(UINT uNotifyCode, int nID, HWND hWndCtl)
	{
		DoDataExchange(TRUE);

		DWORD		dwExProp  = 0;
		dwExProp  |= btn2ExProp(m_nImage		, EXPROP_DLIMAGE	);
		dwExProp  |= btn2ExProp(m_nVideo		, EXPROP_VIDEO 	 	);
		dwExProp  |= btn2ExProp(m_nSound		, EXPROP_SOUND 	 	);
		dwExProp  |= btn2ExProp(m_nRunActiveX	, EXPROP_RUNACTIVEX );
		dwExProp  |= btn2ExProp(m_nDLActiveX	, EXPROP_DLACTIVEX  );
		dwExProp  |= btn2ExProp(m_nScript		, EXPROP_SCRIPT	 	);
		dwExProp  |= btn2ExProp(m_nJava			, EXPROP_JAVA		);

		dwExProp  |= btn2ExProp(m_nNaviLock		, EXPROP_NAVI		);
		dwExProp  |= btn2ExProp(m_nFilter		, EXPROP_FILTER	 	);
		dwExProp  |= btn2ExProp(m_nGesture 		, EXPROP_GETSTURE	);
		dwExProp  |= btn2ExProp(m_nBlockMailTo	, EXPROP_MAILTO		);

		if (m_nReload != -1)
			dwExProp |= (EXPROP_REFRESH_NONE << m_nReload);

		m_dwExProp = dwExProp;

		// Z[u
	  #ifndef USE_DIET
		m_rRsltFlags  = int(m_bRegex);
	  #endif
		m_rRsltExopts = dwExProp;

		//+++ URL ̕ҏWsꍇ
		CString 	strUrl = MtlGetWindowText( GetDlgItem(IDC_EDIT_EXPROP_URL) );
		if (m_rRsltUrl != strUrl) {
			m_rRsltUrl   = strUrl;
		}

		EndDialog(nID);
	}


	void OnCancel(UINT uNotifyCode, int nID, HWND hWndCtl)
	{
		EndDialog(nID);
	}


	void OnDelete(UINT uNotifyCode, int nID, HWND hWndCtl)
	{
		m_nImage		= 0;
		m_nVideo		= 0;
		m_nSound		= 0;
		m_nRunActiveX	= 0;
		m_nDLActiveX	= 0;
		m_nScript		= 0;
		m_nJava 		= 0;
		m_nNaviLock 	= 0;
		m_nFilter		= 0;
		m_nGesture		= 0;
		m_nBlockMailTo	= 0;
		m_nReload		= 0;

	  #ifndef USE_DIET
		m_bRegex		= 0;
	  #endif
		DoDataExchange(FALSE);
	}


	void OnDefault(UINT uNotifyCode, int nID, HWND hWndCtl)
	{
		DWORD dwDLFlag	= CDLControlOption::s_dwDLControlFlags;
		DWORD dwExStyle = CDLControlOption::s_dwExtendedStyleFlags;

		//m_bRegex		= 0;
		m_nReload	   	= 0;

		m_nImage	   	=  (dwDLFlag & DLCTL_DLIMAGES		 )	!= 0;
		m_nVideo	   	=  (dwDLFlag & DLCTL_VIDEOS			 )	!= 0;
		m_nSound	   	=  (dwDLFlag & DLCTL_BGSOUNDS		 )	!= 0;
		m_nRunActiveX  	= !(dwDLFlag & DLCTL_NO_RUNACTIVEXCTLS);
		m_nDLActiveX   	= !(dwDLFlag & DLCTL_NO_DLACTIVEXCTLS );
		m_nScript	   	= !(dwDLFlag & DLCTL_NO_SCRIPTS		 );
		m_nJava 	   	= !(dwDLFlag & DLCTL_NO_JAVA 		 );

		m_nNaviLock    	=  (dwExStyle & DVS_EX_OPENNEWWIN	 )	!= 0;
		m_nFilter	   	=  (dwExStyle & DVS_EX_MESSAGE_FILTER )	!= 0;
		m_nGesture	   	=  (dwExStyle & DVS_EX_MOUSE_GESTURE  )	!= 0;
		m_nBlockMailTo 	=  (dwExStyle & DVS_EX_BLOCK_MAILTO	 )	!= 0;

		DoDataExchange(FALSE);
	}


	void OnDfltBase(UINT uNotifyCode, int nID, HWND hWndCtl)
	{
		m_nReload	    = 0;

		m_nImage		= BST_INDETERMINATE;
		m_nVideo		= BST_INDETERMINATE;
		m_nSound		= BST_INDETERMINATE;
		m_nRunActiveX	= BST_INDETERMINATE;
		m_nDLActiveX	= BST_INDETERMINATE;
		m_nScript		= BST_INDETERMINATE;
		m_nJava 		= BST_INDETERMINATE;
		m_nNaviLock 	= BST_INDETERMINATE;
		m_nFilter		= BST_INDETERMINATE;
		m_nGesture		= BST_INDETERMINATE;
		m_nBlockMailTo	= BST_INDETERMINATE;

		DoDataExchange(FALSE);
	}


  #if 1	//+++ URL ҏW\ɕύX. URL\Ȃꍇ́AURL{^Ȃ.
	void OnBtnExpropUrl(UINT uNotifyCode, int nID, HWND hWndCtl)
	{
		CEdit( GetDlgItem(IDC_EDIT_EXPROP_URL) ).SetReadOnly( m_urlEditBtnSw );
		m_urlEditBtnSw ^= 1;
		//DoDataExchange(FALSE);
	}
  #endif

};

